#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "xml_trace_ace4xi.py">
#<abstract4xi abstract = "aces tracing and produces XML"/>
#<refer4xi reference = "yourDragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "Acing possibility also as email, multimedia message, text messages, video etc"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'xml_trace_ace4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    from time import localtime, strftime         
except:
    pass
     
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


        
# -------------------------------------------------------------------------------------------------
# xml_trace_ace4xi                            
# -------------------------------------------------------------------------------------------------    
def xml_trace_ace4xi (xml_trace_ace4xi_param1, xml_trace_ace4xi_param2 = 
    {'file_path4xi': '..\\..\\xml\\ace-default4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values detected.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="acing#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">ACE</rdfs:comment>\n',
     'debug4xi': True}):
    
    
    '''
    xml_trace_ace4xi aces traced knowledgebase producing XML
    
    '''       
    # ---------------------------------------------------------------------------------------------
    # START
    # ---------------------------------------------------------------------------------------------    
    try:
        t2xi = xml_trace_ace4xi_param1 # pointer to Print4Xi object, mandatory
        c2xi = xml_trace_ace4xi_param2 # context, optional
        keys2context = c2xi.keys()
    except:
        pass
        
    # ---------------------------------------------------------------------------------------------
    # TAILOR 
    # ---------------------------------------------------------------------------------------------     
    try:
        if 'debug4xi' in keys2context:
            debug2xi = c2xi['debug4xi']     
        else:
            debug2xi = False
    except:
        pass
           
    # ---------------------------------------------------------------------------------------------
    # ACE
    # --------------------------------------------------------------------------------------------- 
    if debug2xi is True:
        print(33*("="))
        print("xml_trace_ace4xi: ACING")
        print(33*("="))
    
        print(33*("-"))
        print("xml_trace_ace4xi: Input from Print4Xi ace method")
        print(33*("-"))
        print("")
        print("xml_trace_ace4xi: set c2xi to: ", c2xi)
        print("")
    
    try:            
        kbase8xi = t2xi.ace() 
        len8kb= len(kbase8xi)
        keys8kb = kbase8xi.keys()    
    except:
        pass
            
    if debug2xi is True:
        try:    
            for key4kb in sorted(keys8kb):
                print()
                print(key4kb)                     #<object4xi>Popen4Xi#145</object4xi>
                              
                print(21*(" "), kbase8xi[key4kb]) #<value4xi> <class 'popen4xi.Popen4Xi'></value4xi>
    
        
        
            print(33*("-"))
            print("xml_trace_ace4xi: create ACE XML file")
            print(33*("-"))
        except:
            pass 
                     

    # ---------------------------------------------------------------------------------------------
    # TAILOR 
    # ---------------------------------------------------------------------------------------------        
    try:
        if 'file_path4xi' in keys2context:
            filepath2xi = c2xi['file_path4xi'] 
        else:
            filepath2xi = '..\\..\\xml\\ace-test-default4xi.xml' 
    except:
        pass
        
    # ---------------------------------------------------------------------------------------------
    # OPEN
    # ---------------------------------------------------------------------------------------------        
    try:                
        f2xi=open(filepath2xi, 'w') 
    except:
        pass
            
    # ---------------------------------------------------------------------------------------------
    # WRITE HEADERS
    # --------------------------------------------------------------------------------------------- 
    
    if debug2xi is True:
        print(33*("="))
        print("xml_trace_ace4xi: opened XML file: ", filepath2xi)          
        print(33*("="))
        
        print(33*("-"))
        print("xml_trace_ace4xi: create header for XML file")     
        print(33*("-"))    
    try:                    
        f2xi.write('<?xml version="1.0"?>\n')
        f2xi.write('<rdf:RDF\n')
        f2xi.write('   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n')
        f2xi.write('   xmlns:xsd="http://www.w3.org/2001/XMLSchema#"\n')
        f2xi.write('   xmlns:owl="http://www.w3.org/2002/07/owl#"\n')
        f2xi.write('   xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"\n')
    except:
        pass
            
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE 
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'name_space4xi' in keys2context:
            namespace2xi = c2xi['name_space4xi'] 
        else:
            namespace2xi = '   xmlns="http://www.yourdragonxi.org/web/lib/owl/Ace4Xi.owl#"\n'    
        
        f2xi.write(namespace2xi)
    except:
        pass    
    
    # ---------------------------------------------------------------------------------------------
    # WRITE ONTOLOGY
    # --------------------------------------------------------------------------------------------- 
    try:   
        f2xi.write('   xmlns:p1="http://www.owl-ontologies.com/assert.owl#"\n')
    except:
        pass      
    
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'xml_base4xi' in keys2context: 
            xmlbase2xi = c2xi['xml_base4xi'] 
        else:
            xmlbase2xi = '   xml:base="http://www.yourdragonxi.org.com/web/lib/owl/ace-test-cpu-corecount4xi.owl">\n'    
        f2xi.write(xmlbase2xi) 
    except:
        pass          

    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'ontology_about4xi' in keys2context: 
            ontology_about2xi = c2xi['ontology_about4xi']
        else:
            ontology_about2xi = '   <owl:Ontology rdf:about="DefaultAcing4Xi">\n'    
        f2xi.write(ontology_about2xi)    
    except:
        pass   
        
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'ontology_comment4xi' in keys2context:
            ontology_comment2xi = c2xi['ontology_comment4xi']
        else:
            ontology_comment2xi = '      <rdfs:comment xml:lang="en">ace-default4xi</rdfs:comment>\n'    
        
        f2xi.write(ontology_comment2xi)      
    except:
        pass   
    # ---------------------------------------------------------------------------------------------
    # WRITE
    # ---------------------------------------------------------------------------------------------          
    try:    
        f2xi.write('      <owl:versionInfo xml:lang="en">Version ' + strftime("%a, %d %b %Y %H:%M:%S",localtime()) + '</owl:versionInfo>\n')
    except:
        pass      
    
  
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'class0_id4xi' in keys2context:
            class_id2xi = c2xi['class0_id4xi']
        else:
            class_id2xi = '   <owl:Class rdf:ID="Ace4Xi#0">\n'   
        
        f2xi.write(class_id2xi)
    except:
        pass               

    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------         
    try:
        if 'class0_comment4xi' in keys2context:
            class_comment2xi = c2xi['class0_comment4xi']
        else:
            class_comment2xi = '      <rdfs:comment xml:lang="en">aced</rdfs:comment>\n'    
            
        f2xi.write(class_comment2xi)    
    except:
        pass  
       
    # ---------------------------------------------------------------------------------------------
    # WRITE
    # ---------------------------------------------------------------------------------------------         
    try:    
        f2xi.write('   </owl:Class>\n')
    except:
        pass      
    
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'object_property_rdf4xi' in keys2context:
            object_property2xi = c2xi['object_property_rdf4xi']
        else:
            object_property2xi = '   <owl:ObjectProperty rdf:ID="acing">\n'    
        f2xi.write(object_property2xi)
    except:
        pass          
       
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------          
    try:
        if 'object_property_comment4xi' in keys2context:
            object_property_comment2xi = c2xi['object_property_comment4xi']
        else:
            object_property_comment2xi = '       <rdfs:comment xml:lang="en">cpu</rdfs:comment>\n'    
        f2xi.write(object_property_comment2xi)    
    except:
        pass    
    # ---------------------------------------------------------------------------------------------
    # WRITE
    # ---------------------------------------------------------------------------------------------          
    try:       
        f2xi.write('   </owl:ObjectProperty>\n')        
    except:
        pass 
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------         
    valueIRI2xi = 'to-be-solved-value'
    
    try:
        for key8kb in sorted(keys8kb):
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------      
            #print('key8kb: ', key8kb)
            #print('kbase8xi[key8kb] = ', kbase8xi[key8kb])                            #key8kb:  <object4xi>ORIGINAL_DIR4XI#114</object4xi>
                                                                                       #kbase8xi[key8kb] =  <value4xi> e:\Sw4Xi\python32\Lib\multiprocessing4xi</value4xi>
                                                                                       #kbase8xi[key8kb] =  <value4xi> <class 'popen4xi.Popen4Xi'></value4xi>
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------                                                                                    
            while 1:
                try:                                                                              
                    start_index2object = str.find(key8kb,'<object4xi>')                   #<object4xi>ORIGINAL_DIR4XI#114</object4xi>
                    end_index2object = str.find(key8kb,'</object4xi>')
                         
                    if (end_index2object == -1) or (start_index2object == -1):
                        print("*** error: did not find <object4xi> inside key8kb: ", key8kb)   
                        break
                    else:
                        objectIRI2xi = key8kb[start_index2object+11:end_index2object]     #<class 'popen4xi.Popen4Xi'> 
                        break
                except:
                    break                
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------                       
            while 1:
                try:                                                                                          
                    start_index2value = str.find(kbase8xi[key8kb],'<value4xi>')           #<value4xi> e:\Sw4Xi\python32\Lib\multiprocessing4xi</value4xi>
                    end_index2value = str.find(kbase8xi[key8kb],'</value4xi>')
                         
                    if (end_index2value == -1) or (start_index2value == -1):
                        print("*** error: did not find <value4xi> inside key8kb: ", key8kb)   
                        break
                    else:
                        value8xi = kbase8xi[key8kb]
                        valueIRI2xi = value8xi[start_index2value+10:end_index2value]      # e:\Sw4Xi\python32\Lib\multiprocessing4xi
                        break                                                             # <class 'popen4xi.Popen4Xi'>   
                except:
                    break       
                                                                                      
                                                                                        
    
            # --------------------------------------------------------------------------------------------------------------
            # ACE: moved filtering < and > tags in messages to print4xi.py
            # --------------------------------------------------------------------------------------------------------------        
            commentIRI2xi = valueIRI2xi                            # <class 'popen4xi.Popen4Xi'> 
            
          
            
                    
            # --------------------------------------------------------------------------------------------------------------
            # ACE
            # --------------------------------------------------------------------------------------------------------------           
            try:
                f2xi.write('   <owl:Class rdf:ID="' + objectIRI2xi + '">\n')    
                if debug2xi is True:
                    print("ACE writing: ", commentIRI2xi)
                
                
                f2xi.write('      <rdfs:comment xml:lang="en">' + commentIRI2xi + '</rdfs:comment>\n') 
                f2xi.write('   </owl:Class>\n') 
            except:
                pass 
            
    except:
        pass 
                               
    # ---------------------------------------------------------------------------------------------
    # END OF ONTOLOGY, RDF AND COPYRIGHT
    # ---------------------------------------------------------------------------------------------  
    try:        
        f2xi.write('   </owl:Ontology>\n')
        f2xi.write('</rdf:RDF>\n')
        f2xi.write('<!-- Copyright Small & Smart Inc. All rights reserved. -->\n')
    except:
        pass      
    
    # ---------------------------------------------------------------------------------------------
    # CLOSE
    # ---------------------------------------------------------------------------------------------  
    try:      
        f2xi.close()   
    except:
        pass  
        
    # ---------------------------------------------------------------------------------------------
    # end of ace_trace4xi    
    # ---------------------------------------------------------------------------------------------
    if debug2xi is True:    
        print(33*("-"))
        print("xml_trace_ace4xi: closed ACE XML file")
        print(33*("-"))
        
#</program4xi>
         
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   ace*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of xml_trace_ace4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

